#! /usr/local/bin/perl
# CBJ 19.10.99
# procres.pl
#
# To run: procres.pl <name of .ot file to process>
# Input:  Any of the .ot files produced by statnet (version 2.00)
#         Must be .ot file type without results from every single
#         network, but only the committee
# Output: One line for each output parameter giving three summary 
#         statistics:
#          1. Parameter number
#          2. RMS_ext_error
#          3. Av_abs_ext_error
#          4. Av_int_error
#
# Framework program for producing summary statistics from .ot file.
# Specific function achieved by editing the program, e.g. to produce
# statistics for only a limited range of the output parameters.
# Note that the program reads number of outputs from header


open(INF, "<$ARGV[0]") or die "Could not open file $ARGV[0]\n";

$line = <INF>;$line = <INF>;$line = <INF>;$line = <INF>;$line = <INF>;
$line = <INF>;
@fi = split(" ", $line);
$Noutputs = $fi[1];

# read in
$line = <INF>;
$s=0;
while ($line = <INF>) {
    $s++;
    @fi = split(" ", $line);
    for($i=1;$i<=$Noutputs;$i++) {
	$com[$s][$i]   =$fi[1+4*($i-1)-1];
	$true[$s][$i]  =$fi[2+4*($i-1)-1];
	$diff[$s][$i]  =$fi[3+4*($i-1)-1];
	$interr[$s][$i]=$fi[4+4*($i-1)-1];
    }
###### put your selections for rejecting in the if clause ######
    if($true[$s][3]<=4.0) {
	$s--;
    }
}
$Nspectra=$s;
#printf STDOUT "%3d\n", $Nspectra;
if($Nspectra<2) {
    die "Number of suitable spectra is fewer than two!\n"
}

# initialise
for($i=1;$i<=$Noutputs;$i++) {
    $rmsexterr[$i]=0.0;
    $avabsexterr[$i]=0.0;
    $avinterr[$i]=0.0;
}

# evaluate summed errors
for($s=1;$s<=$Nspectra;$s++) {
    for($i=1;$i<=$Noutputs;$i++){
	$rmsexterr[$i]+=($diff[$s][$i])**2;
	if($diff[$s][$i]<0.0) {
	    $avabsexterr[$i]-=$diff[$s][$i]; }
	else {
	    $avabsexterr[$i]+=$diff[$s][$i]; }
	$avinterr[$i]+=$interr[$s][$i];
    }
}
 
# average the errors
for($i=1;$i<=$Noutputs;$i++){
    $rmsexterr[$i]/=($Nspectra-1);
    $rmsexterr[$i]=sqrt($rmsexterr[$i]);
    $avabsexterr[$i]/=$Nspectra;
    $avinterr[$i]/=$Nspectra;
    printf STDOUT "%3d    %4d    %d    %6.4f    %6.4f    %6.4f\n", $ARGV[1], $ARGV[2], $i, $rmsexterr[$i], $avabsexterr[$i], $avinterr[$i];
}

